package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.OtnAreaEntity;
import com.example.entity.vo.housemanager.WzBuildmanageAvageareaVo;
import com.example.service.WzBuildmanageAvageareaService;
import com.example.service.WzOtnAreaService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/house-car/house/dist/api/WzBuildmanageAvagearea")
public class WzBuildmanageAvageareaController {

    @Autowired
    private WzBuildmanageAvageareaService wzBuildmanageAvageareaService;
    @Autowired
    private WzOtnAreaService otnAreaService;

    /**
     * 自有房产人均办公面积-----一个接口整个界面
     */
    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        //全省节点
        WzBuildmanageAvageareaVo province = new WzBuildmanageAvageareaVo();
        double pareaNum = 0l;
        double pallEmp = 0l;

        List<WzBuildmanageAvageareaVo> appointmentRecordList = wzBuildmanageAvageareaService.queryVoList(query);
        Map<String, List<WzBuildmanageAvageareaVo>> map = new HashMap<>();
        for (WzBuildmanageAvageareaVo wzBuildmanageAvageareaVo : appointmentRecordList) {
            double avera = wzBuildmanageAvageareaVo.getOfficeArea() / wzBuildmanageAvageareaVo.getEmployees();
            avera = formatDouble(avera);
            wzBuildmanageAvageareaVo.setAverage(avera);
            List<WzBuildmanageAvageareaVo> list;
            if (map.get(wzBuildmanageAvageareaVo.getCity()) != null) {
                list = map.get(wzBuildmanageAvageareaVo.getCity());
                list.add(wzBuildmanageAvageareaVo);
            } else {
                list = new ArrayList<>();
                list.add(wzBuildmanageAvageareaVo);
            }
            map.put(wzBuildmanageAvageareaVo.getCity(), list);
            pareaNum += wzBuildmanageAvageareaVo.getOfficeArea();
            pallEmp += wzBuildmanageAvageareaVo.getEmployees();
        }
        pareaNum = formatDouble(pareaNum);
        double pavera = 0;
        if (pallEmp != 0) {
            pavera = formatDouble(pareaNum / pallEmp);
        }
        province.setOfficeArea(pareaNum);
        province.setEmployees(pallEmp);
        province.setCountyName("全省");
        province.setCity("全省");
        province.setAverage(pavera);

        List<WzBuildmanageAvageareaVo> resultList = new ArrayList<>();
        List<WzBuildmanageAvageareaVo> cityList = new ArrayList<>();

        double allareaNum = 0l;
        double allEmp = 0l;
        for (Map.Entry<String, List<WzBuildmanageAvageareaVo>> entry : map.entrySet()) {

            List<WzBuildmanageAvageareaVo> list = entry.getValue();
            double cityAreaNum=0l;
            double cityEmp=0l;
            //县的Map集合
            Map<String, List<WzBuildmanageAvageareaVo>> countyMap = new HashMap<>();
            for (WzBuildmanageAvageareaVo leaveUseVo : list) {
                if (countyMap.get(leaveUseVo.getCounty()) != null) {
                    list = countyMap.get(leaveUseVo.getCounty());
                    list.add(leaveUseVo);
                } else {
                    list = new ArrayList<>();
                    list.add(leaveUseVo);
                }
                countyMap.put(leaveUseVo.getCounty(), list);
            }

            List<WzBuildmanageAvageareaVo> countyList = new ArrayList<>();
            for (Map.Entry<String, List<WzBuildmanageAvageareaVo>> countyEntry : countyMap.entrySet()) {
                double areaNum=0l;
                double emp=0l;
                for (WzBuildmanageAvageareaVo wzBuildmanageAvageareaVo : countyEntry.getValue()) {
                    areaNum += wzBuildmanageAvageareaVo.getOfficeArea();
                    emp += wzBuildmanageAvageareaVo.getEmployees();
                    cityAreaNum += wzBuildmanageAvageareaVo.getOfficeArea();
                    cityEmp += wzBuildmanageAvageareaVo.getEmployees();
                    allareaNum += wzBuildmanageAvageareaVo.getOfficeArea();
                    allEmp += wzBuildmanageAvageareaVo.getEmployees();
                }
                WzBuildmanageAvageareaVo countyObject = new WzBuildmanageAvageareaVo();
                double avera = formatDouble(areaNum / emp);
                countyObject.setOfficeArea(formatDouble(areaNum));
                countyObject.setEmployees(emp);
                countyObject.setCity(countyEntry.getValue().get(0).getCounty());
                countyObject.setCountyName(list.get(0).getCityName());
                countyObject.setAverage(formatDouble(avera));
                countyList.add(countyObject);
            }

            List<WzBuildmanageAvageareaVo> orderCountyList = new ArrayList<>();
            try {
                //对countList 进行排序
                OtnAreaEntity area = otnAreaService.queryObject(list.get(0).getCity());
                List<OtnAreaEntity> countyAreaList = otnAreaService.getCityOption(area.getId());
                int i=0;
                for (OtnAreaEntity otnAreaEntity : countyAreaList) {
                    for (WzBuildmanageAvageareaVo wzCity : countyList) {
                        if (wzCity.getCity().contains(otnAreaEntity.getName())) {
                            i++;
                            wzCity.setFlag(i%2==0);
                            orderCountyList.add(wzCity);
                        }
                    }
                }
            } catch (Exception e) {
                orderCountyList = countyList;
                e.printStackTrace();
            }

            double cityavera = formatDouble(cityAreaNum / cityEmp);
            WzBuildmanageAvageareaVo cityObject = new WzBuildmanageAvageareaVo();
            cityObject.setOfficeArea(formatDouble(cityAreaNum));
            cityObject.setEmployees(cityEmp);
            cityObject.setCity(list.get(0).getCity());
            cityObject.setCountyName(list.get(0).getCityName());
            cityObject.setAverage(formatDouble(cityavera));
            cityObject.setChildren(orderCountyList);
            cityList.add(cityObject);
        }
        //对cityList 进行排序
        List<OtnAreaEntity> areaList = otnAreaService.getCityOption("018");
        List<WzBuildmanageAvageareaVo> orderList = new ArrayList<>();
        int i=0;
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzBuildmanageAvageareaVo wzCity : cityList) {
                if (wzCity.getCity().contains(otnAreaEntity.getName())) {
                    wzCity.setFlag(i%2==0);
                    orderList.add(wzCity);
                    i++;
                }
            }
        }
        province.setChildren(orderList);
        if(orderList.size()>0){
            resultList.add(province);
        }
        int total = wzBuildmanageAvageareaService.queryTotal(query);
        PageUtils pageUtil = new PageUtils(resultList, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    public double formatDouble(double num) {
        if (num == 0) return 0;
        DecimalFormat format2 = new DecimalFormat("#.00");
        String str2 = format2.format(num);
        double avera = Double.parseDouble(str2);
        return avera;
    }
}
