package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.OtnAreaEntity;
import com.example.entity.WzHouseInCustomerEntity;
import com.example.service.WzHouseInCustomerService;
import com.example.service.WzOtnAreaService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 房屋租入(客户管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzHouseInCustomer")
public class WzHouseInCustomerController {

    @Autowired
    private WzHouseInCustomerService wzHouseInCustomerService;

    @Autowired
    private WzOtnAreaService otnAreaService;

    @RequestMapping("/echartList")
    @IgnoreAuth
    public R echartList(@RequestBody PageMap pageMap) {

        List<WzHouseInCustomerEntity> resultList = new ArrayList<>();

        //查询列表数据
        Query query = new Query(pageMap);
        List<WzHouseInCustomerEntity> wzHouseInCustomerEntityList = wzHouseInCustomerService.queryList(query);

        Map<String, List<WzHouseInCustomerEntity>> cityMap = new HashMap<>();
        for (WzHouseInCustomerEntity wzHouseInCustomer : wzHouseInCustomerEntityList) {
            List<WzHouseInCustomerEntity> list;
            if (cityMap.get(wzHouseInCustomer.getStandardAddressLevel2()) != null) {
                list = cityMap.get(wzHouseInCustomer.getStandardAddressLevel2());
                list.add(wzHouseInCustomer);
            } else {
                list = new ArrayList<>();
                list.add(wzHouseInCustomer);
            }
            cityMap.put(wzHouseInCustomer.getStandardAddressLevel2(), list);
        }

        Integer allPerson = 0;                           // 个人
        Integer allPersonPrivate = 0;                    // 私企
        Integer allStateOwnedEnterprises = 0;            // 国企
        Integer allGovernment = 0;                       // 政府
        Integer allVillageAndTownColletive = 0;          // 村镇集体
        Integer allAllNum = 0;                           // 总计
        List<WzHouseInCustomerEntity> cityList = new ArrayList<>();
        for (Map.Entry<String, List<WzHouseInCustomerEntity>> entry : cityMap.entrySet()) {
            List<WzHouseInCustomerEntity> list = entry.getValue();
            if (list.get(0).getStandardAddressLevel2().equals("全省")) {
                continue;
            }

            //县的Map集合
            Map<String, List<WzHouseInCustomerEntity>> countyMap = new HashMap<>();
            for (WzHouseInCustomerEntity leaveUseVo : list) {
                if (leaveUseVo.getStandardAddressLevel3() == null || leaveUseVo.getStandardAddressLevel3().equals("")) {
                    continue;
                }
                if (countyMap.get(leaveUseVo.getStandardAddressLevel3()) != null) {
                    list = countyMap.get(leaveUseVo.getStandardAddressLevel3());
                    list.add(leaveUseVo);
                } else {
                    list = new ArrayList<>();
                    list.add(leaveUseVo);
                }
                countyMap.put(leaveUseVo.getStandardAddressLevel3(), list);
            }
            Integer cityPerson = 0;                           // 个人
            Integer cityPersonPrivate = 0;                    // 私企
            Integer cityStateOwnedEnterprises = 0;            // 国企
            Integer cityGovernment = 0;                       // 政府
            Integer cityVillageAndTownColletive = 0;          // 村镇集体
            Integer cityAllNum = 0;                           // 总计
            List<WzHouseInCustomerEntity> countyList=new ArrayList<>();
            for (Map.Entry<String, List<WzHouseInCustomerEntity>> countyEntry : countyMap.entrySet()) {
                Integer person = 0;                           // 个人
                Integer personPrivate = 0;                    // 私企
                Integer stateOwnedEnterprises = 0;            // 国企
                Integer government = 0;                       // 政府
                Integer villageAndTownColletive = 0;          // 村镇集体
                Integer allNum = 0;                           // 总计
                for (WzHouseInCustomerEntity wzHouseInCustomerEntity : countyEntry.getValue()) {
                    if(wzHouseInCustomerEntity.getPersonal()!=null&&!wzHouseInCustomerEntity.getPersonal().equals("")){
                        person+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                        cityPerson+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                        allPerson+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                        allNum+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                        cityAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                        allAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getPersonal());
                    }
                    if(wzHouseInCustomerEntity.getPrivateEnterprise()!=null&&!wzHouseInCustomerEntity.getPrivateEnterprise().equals("")){
                        personPrivate+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                        cityPersonPrivate+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                        allPersonPrivate+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                        allNum+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                        cityAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                        allAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getPrivateEnterprise());
                    }
                    if(wzHouseInCustomerEntity.getStateOwnedEnterprise()!=null&&!wzHouseInCustomerEntity.getStateOwnedEnterprise().equals("")){
                        stateOwnedEnterprises+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                        cityStateOwnedEnterprises+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                        allStateOwnedEnterprises+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                        allNum+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                        cityAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                        allAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getStateOwnedEnterprise());
                    }
                    if(wzHouseInCustomerEntity.getGovernment()!=null&&!wzHouseInCustomerEntity.getGovernment().equals("")){
                        government+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                        cityGovernment+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                        allGovernment+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                        allNum+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                        cityAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                        allAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getGovernment());
                    }
                    if(wzHouseInCustomerEntity.getVillageAndTownColletive()!=null&&!wzHouseInCustomerEntity.getVillageAndTownColletive().equals("")){
                        villageAndTownColletive+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                        cityVillageAndTownColletive+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                        allVillageAndTownColletive+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                        allNum+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                        cityAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                        allAllNum+=Integer.parseInt(wzHouseInCustomerEntity.getVillageAndTownColletive());
                    }
                }
                WzHouseInCustomerEntity wzHouseInCustomerEntity = countyEntry.getValue().get(0);
                wzHouseInCustomerEntity.setPersonal(person+"");
                wzHouseInCustomerEntity.setGovernment(government+"");
                wzHouseInCustomerEntity.setPrivateEnterprise(personPrivate+"");
                wzHouseInCustomerEntity.setStateOwnedEnterprise(stateOwnedEnterprises+"");
                wzHouseInCustomerEntity.setVillageAndTownColletive(villageAndTownColletive+"");
                wzHouseInCustomerEntity.setAllNum(allNum+"");
                wzHouseInCustomerEntity.setStandardAddressLevel2(wzHouseInCustomerEntity.getStandardAddressLevel3());
                countyList.add(wzHouseInCustomerEntity);
            }

            List<WzHouseInCustomerEntity> orderCountyList=new ArrayList<>();
            try{
                //对countList 进行排序
                String city=list.get(0).getStandardAddressLevel2();
                if(city.contains("市")){
                    city=city.split("市")[0];
                }
                OtnAreaEntity area=otnAreaService.queryObject(city);
                List<OtnAreaEntity> countyAreaList=otnAreaService.getCityOption(area.getId());
                for (OtnAreaEntity otnAreaEntity : countyAreaList) {
                    for (WzHouseInCustomerEntity wzCity : countyList) {
                        if(wzCity.getStandardAddressLevel3().contains(otnAreaEntity.getName())){
                            orderCountyList.add(wzCity);
                        }
                    }
                }
            }catch (Exception e){
                orderCountyList=countyList;
                e.printStackTrace();
            }

            //城市的统计
            WzHouseInCustomerEntity cityObject=new WzHouseInCustomerEntity();
            cityObject.setStandardAddressLevel2(entry.getKey());
            cityObject.setStandardAddressLevel3(entry.getKey());
            cityObject.setPersonal(cityPerson+"");
            cityObject.setPrivateEnterprise(cityPersonPrivate+"");
            cityObject.setGovernment(cityGovernment+"");
            cityObject.setStateOwnedEnterprise(cityStateOwnedEnterprises+"");
            cityObject.setVillageAndTownColletive(cityVillageAndTownColletive+"");
            cityObject.setAllNum(cityAllNum+"");
            cityObject.setChildren(orderCountyList);
            cityList.add(cityObject);
        }

        //对cityList 进行排序
        List<OtnAreaEntity> areaList=otnAreaService.getCityOption("018");
        List<WzHouseInCustomerEntity> orderList=new ArrayList<>();
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzHouseInCustomerEntity wzCity : cityList) {
                if(wzCity.getStandardAddressLevel2().contains(otnAreaEntity.getName())){
                    orderList.add(wzCity);
                }
            }
        }

        //城市的统计
        WzHouseInCustomerEntity provinceObject=new WzHouseInCustomerEntity();
        provinceObject.setStandardAddressLevel2("全省");
        provinceObject.setStandardAddressLevel3("全省");
        provinceObject.setPersonal(allPerson+"");
        provinceObject.setPrivateEnterprise(allPersonPrivate+"");
        provinceObject.setGovernment(allGovernment+"");
        provinceObject.setStateOwnedEnterprise(allStateOwnedEnterprises+"");
        provinceObject.setVillageAndTownColletive(allVillageAndTownColletive+"");
        provinceObject.setAllNum(allAllNum+"");
        provinceObject.setChildren(orderList);
        resultList.add(provinceObject);
        PageUtils pageUtil = new PageUtils(resultList, 0, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

}
