package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.WzRemarkEntity;
import com.example.service.WzRemarkService;
import com.example.utils.PageMap;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzRemark")
public class WzRemarkController {

    @Autowired
    private WzRemarkService wzRemarkService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzRemarkEntity> list = wzRemarkService.queryList(query);
        return R.ok().put("list", list);
    }

}
