package com.example.controller.house;

import com.example.pojo.dto.ListBuildingIdleDto;
import com.example.service.house.HouseWzBuildManageDetailsService;
import com.example.utils.R;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Tag(name = "不动产建筑")
@Slf4j
@RequestMapping("/house-car/house/dist/api/WzBuildManageDetails")
@RestController
public class HouseWzBuildManageDetailsController {
    private final HouseWzBuildManageDetailsService houseWzBuildManageDetailsService;

    public HouseWzBuildManageDetailsController(HouseWzBuildManageDetailsService houseWzBuildManageDetailsService) {
        this.houseWzBuildManageDetailsService = houseWzBuildManageDetailsService;
    }

    @Operation(summary = "空置1000平米以上建筑")
    @PostMapping("/ideList")
    public R ideList(@Valid @RequestBody ListBuildingIdleDto dto) {
        return houseWzBuildManageDetailsService.ideList(dto);
    }

    @Operation(summary = "空置1000平米以上建筑导出")
    @GetMapping("/ideListExport")
    public void ideListExport(@Valid ListBuildingIdleDto dto) {
        houseWzBuildManageDetailsService.ideListExport(dto);
    }
}
