package com.example.controller.house;

import com.example.pojo.dto.ListBuildingHighRepairDto;
import com.example.service.house.HouseWzHouseMaintenaCostService;
import com.example.utils.R;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Tag(name = "不动产管理策略-维修异常监控")
@Slf4j
@RequestMapping("/house-car/house/dist/api/wzHouseMaintenaCost")
@RestController
public class HouseWzHouseMaintenaCostController {
    private final HouseWzHouseMaintenaCostService houseWzHouseMaintenaCostService;

    public HouseWzHouseMaintenaCostController(HouseWzHouseMaintenaCostService houseWzHouseMaintenaCostService) {
        this.houseWzHouseMaintenaCostService = houseWzHouseMaintenaCostService;
    }

    @Operation(summary = "高总价统计")
    @PostMapping("/queryHighPrice")
    public R queryHighPrice(@Valid @RequestBody ListBuildingHighRepairDto dto) {
        return houseWzHouseMaintenaCostService.queryHighPrice(dto);
    }

    @Operation(summary = "高总价统计导出")
    @GetMapping("/queryHighPriceExport")
    public void queryHighPriceExport(@Valid ListBuildingHighRepairDto dto) {
        houseWzHouseMaintenaCostService.queryHighPriceExport(dto);
    }
}
