package com.example.controller.house;

import com.example.service.house.HouseWzOtnAreaService;
import com.example.utils.R;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Tag(name = "不动产组织机构")
@Slf4j
@RequestMapping("/house-car/house/dist/api/wzOtnArea")
@RestController
public class HouseWzOtnAreaController {
    private final HouseWzOtnAreaService houseWzOtnAreaService;

    public HouseWzOtnAreaController(HouseWzOtnAreaService houseWzOtnAreaService) {
        this.houseWzOtnAreaService = houseWzOtnAreaService;
    }

    @Operation(summary = "根据父级组织机构id查询子组织机构列表")
    @PostMapping("/getCityOption/{id}")
    public R getCityOption(@PathVariable("id") String id) {
        return houseWzOtnAreaService.getCityOption(id);
    }
}
