package com.example.dao.house;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.example.entity.house.HouseBuildingHighRepairPo;
import com.example.entity.house.HouseBuildingPo;
import com.example.pojo.bo.ListBuildingIdleBo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface HouseBuildingDao {
    @Select("""
<script>
select
*
from house.building_month
where building_area_idle > 1000
<choose>
  <when test="dto.yearMonth != null">
    and year_month = #{dto.yearMonth}
  </when>
  <otherwise>
    and year_month = (select max(year_month) from house.building_month)
  </otherwise>
</choose>
<if test="dto.areaNo != null and dto.areaNo != ''">
  and area_no = #{dto.areaNo}
</if>
<if test="dto.cityNo != null and dto.cityNo != ''">
  and city_no = #{dto.cityNo}
</if>
</script>
""")
    List<HouseBuildingPo> listBuildingIdle(Page<HouseBuildingPo> page, @Param("dto") ListBuildingIdleBo dto);
}
