package com.example.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 房屋租入（租入用途管理）
 */

@Data
public class WzHouseUseEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Integer id;                              // 行ID
    private String province;                         // 资产所属单位(一级)
    private String city;                             // 资产所属单位(二级)
    private String county;                           // 资产所属单位(三级)
    private double contractAmount;                   // 合同金额
    private double yearContractAmount;               // 合同年金额
    private double unitPricePerSquareMeter;          // 每平米单价
    private double leasedFloorArea;                  // 租入建筑面积
    private String contractStartTime;                // 租入开始时间(合同生效时间)
    private String contractStopTime;                 // 租入终止时间(合同终止时间)
    private String rentalUse;                        // 用途
    private String statisticalMonth;                 // 账期
    private boolean flag;
    private List<WzHouseUseEntity> children;
}
