package com.example.enums;

public enum ListBuildingIdleOrderEnum {
    /**
     * 二级单位
     */
    city("area_name"),
    /**
     * 三级单位
     */
    county("city_name"),
    /**
     * 建筑别名
     */
    buildingAias("building_name"),
    /**
     * 维修类型
     */
    repairType("repair_type"),
    /**
     * 维修内容
     */
    repairContent("content_category"),
    /**
     * 累计维修
     */
    erpCreditedAmount("final_cost_sum"),
    /**
     * 标准地址
     */
    standardAddress("address"),
    /**
     * 建筑用途
     */
    buildingUse("building_use"),
    /**
     * 建筑面积
     */
    buildingArea("building_area"),
    /**
     * 建筑面积自用
     */
    buildingAreaUseArea("building_area_self_use"),
    /**
     * 建筑面积出租
     */
    buildingAreaRentArea("building_area_rent"),
    /**
     * 建筑面积闲置
     */
    buildingAreaIdelArea("building_area_idle"),
    buildingAreaUnavailable("building_area_unusable"),
    province("first_unit"),
    buildingRate("housing_acquisition_rate"),
    parentBuildingName("site_name"),
    parentLandName("land_name"),
    buildingSource("housing_source"),
    getDate("acquisition_date"),
    buildingStartYear("house_year_began"),
    investmentEntity("investor"),
    managementHierarchy("management_level"),
    buildingStructure("building_structure"),
    totalNumberOfFloors("total_floors"),
    buildingFaceStreet("frontage"),
    courtyard("courtyard"),
    wholeBuilding("whole_building"),
    premisesPermit("property_ownership_certificate"),
    noPremisesPermitReason("no_property_ownership_certificate_reason"),
    unrelatedAssets("unrelated_assets"),
    assetCode("assets_num"),
    astsLabe("assets_tag_num"),
    useState("usage_status"),
    ownershipStatus("ownership_status"),
    buildingFloorArea("floor_area"),
    useArea("usable_area"),
    useAreaSelfUseArea("usable_area_self_use"),
    useAreaRentArea("usable_area_rent"),
    useAreaIdelArea("usable_area_idle"),
    useAreaUnavailableArea("usable_area_unusable"),
    landManageName("community_assistant_name"),
    landManageCompany("community_assistant_unit"),
    buildingLongitude("lng_jt"),
    buildingDimension("lat_jt"),
    buildingActualPropertyRights("property_owner"),
    buildingAddressNumber("site_num"),
    buildingNameAlias("site_name"),
    areaSector("area_sector"),
    ;

    private final String columnName;

    ListBuildingIdleOrderEnum(String columnName) {
        this.columnName = columnName;
    }

    public String getColumnName() {
        return columnName;
    }
}
