package com.example.pojo.vo;

import com.example.entity.house.HouseBuildingHighRepairPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class ListBuildingHighRepairVo {
    @Schema(description = "维修类型")
    private String repairType;
    @Schema(description = "维修内容")
    private String repairContent;
    @Schema(description = "erp入账金额元")
    private BigDecimal erpCreditedAmount;
    @Schema(description = "资产所属单位二级")
    private String city;
    @Schema(description = "资产所属单位三级")
    private String county;
    @Schema(description = "标准地址")
    private String standardAddress;
    @Schema(description = "建筑别名")
    private String buildingAlias;
    @Schema(description = "建筑用途")
    private String buildingUse;
    @Schema(description = "建筑面积㎡")
    private BigDecimal buildingArea;
    @Schema(description = "建筑面积自用㎡")
    private BigDecimal buildingAreaUseArea;
    @Schema(description = "建筑面积出租㎡")
    private BigDecimal buildingAreaRentArea;
    @Schema(description = "建筑面积闲置㎡")
    private BigDecimal buildingAreaIdelArea;
    @Schema(description = "建筑面积不可使用㎡")
    private BigDecimal buildingAreaUnavailable;
    @Schema(description = "最近入账日期")
    private Integer statisticalMonth;

    public ListBuildingHighRepairVo(HouseBuildingHighRepairPo bo) {
        this.repairType = bo.getRepairType();
        this.repairContent = bo.getContentCategory();
        this.erpCreditedAmount = bo.getFinalCostSum();
        this.city = bo.getAreaName();
        this.county = bo.getCityName();
        this.standardAddress = bo.getAddress();
        this.buildingAlias = bo.getBuildingName();
        this.buildingUse = bo.getBuildingUse();
        this.buildingArea = bo.getBuildingArea();
        this.buildingAreaUseArea = bo.getBuildingAreaSelfUse();
        this.buildingAreaRentArea = bo.getBuildingAreaRent();
        this.buildingAreaIdelArea = bo.getBuildingAreaIdle();
        this.buildingAreaUnavailable = bo.getBuildingAreaUnusable();
        this.statisticalMonth = bo.getLatestRepairMonth();
    }
}
